--------------------------------------------------------------------------------
-- Company: Digilent Inc.
-- Engineer:Dion Moses
--
-- Create Date:   11:31:13 09/03/2009 
-- Tool versions:  ISE 11
-- Description:  VHDL test bench design to coincide with problem 2 of
-- P4.doc of Digilent's Real Digital 
-- 
-- VHDL Test Bench Created by ISE for module: P4
-- 
-- Dependencies:
-- 
-- Revision: (DionM) : created
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY P4problem2_sch_tb IS
END P4problem2_sch_tb;
ARCHITECTURE behavioral OF P4problem2_sch_tb IS 

   COMPONENT P4problem2
   PORT( B0	:	IN	STD_LOGIC; 
          B1	:	IN	STD_LOGIC; 
          B2	:	IN	STD_LOGIC; 
          B3	:	IN	STD_LOGIC; 
          LED	:	OUT	STD_LOGIC);
   END COMPONENT;

   SIGNAL B0	:	STD_LOGIC:='0';
   SIGNAL B1	:	STD_LOGIC:='0';
   SIGNAL B2	:	STD_LOGIC:='0';
   SIGNAL B3	:	STD_LOGIC:='0';
   SIGNAL LED	:	STD_LOGIC;

	constant period : time := 10 ns;
	
BEGIN

   UUT: P4problem2 PORT MAP(
		B0 => B0, 
		B1 => B1, 
		B2 => B2, 
		B3 => B3, 
		LED => LED
   );

stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for period;	
		B0<= '0';
      B1<= '0';
		B2<= '0';
		B3<= '0';
		
      wait for period;	
		B0<= '0';
      B1<= '0';
		B2<= '0';
		B3<= '1';
		
      wait for period;	
		B0<= '0';
      B1<= '0';
		B2<= '1';
		B3<= '0';
		
      wait for period;	
		B0<= '0';
      B1<= '0';
		B2<= '1';
		B3<= '1';
		
      wait for period;	
		B0<= '0';
      B1<= '1';
		B2<= '0';
		B3<= '0';

      wait for period;	
		B0<= '0';
      B1<= '1';
		B2<= '0';
		B3<= '1';

      wait for period;	
		B0<= '0';
      B1<= '1';
		B2<= '1';
		B3<= '0';

      wait for period;	
		B0<= '0';
      B1<= '1';
		B2<= '1';
		B3<= '1';
		
	   wait for period;	
		B0<= '1';
      B1<= '0';
		B2<= '0';
		B3<= '0';
		
	   wait for period;	
		B0<= '1';
      B1<= '0';
		B2<= '0';
		B3<= '1';
		
	   wait for period;	
		B0<= '1';
      B1<= '0';
		B2<= '1';
		B3<= '0';

	   wait for period;	
		B0<= '1';
      B1<= '0';
		B2<= '1';
		B3<= '1';
		
	   wait for period;	
		B0<= '1';
      B1<= '1';
		B2<= '0';
		B3<= '0';

	   wait for period;	
		B0<= '1';
      B1<= '1';
		B2<= '0';
		B3<= '1';
		
	   wait for period;	
		B0<= '1';
      B1<= '1';
		B2<= '1';
		B3<= '0';
		
	   wait for period;	
		B0<= '1';
      B1<= '1';
		B2<= '1';
		B3<= '1';
      -- insert stimulus here 

      wait;
   end process;

END;
